﻿local Gnoll = _G.Gnoll

local EJ = {}
local eventFrame = CreateFrame("FRAME")
local itemList = {}
local currentQuery = {}

local EJ_SelectInstance, EJ_SelectEncounter, EJ_SetDifficulty, EJ_SetLootFilter = EJ_SelectInstance, EJ_SelectEncounter, EJ_SetDifficulty, EJ_SetLootFilter
local EJ_GetEncounterInfo, EJ_GetLootInfoByIndex, EJ_GetNumLoot = EJ_GetEncounterInfo, EJ_GetLootInfoByIndex, EJ_GetNumLoot

local function OnEvent(self, event, arg1)
	local classID, specID = EJ_GetLootFilter()
	if EJ_GetEncounterInfo(currentQuery[2][1]) ~= currentQuery[2][2] or EJ_GetDifficulty() ~= currentQuery[3] or EJ_GetCurrentTier() ~= currentQuery[4] or classID ~= currentQuery[5] or specID ~= currentQuery[6] then
	   EJ:ClearQuery()
		return
	end
	
	local x, itemID, link
	for i = 1, EJ_GetNumLoot() do
		itemID, x, x, x , slot, armortype, link = EJ_GetLootInfoByIndex(i)
		itemList[i] = { itemID, link, slot, armortype }
		itemList[itemID] = i
	end
	self.OnUpdate(itemList)
end
eventFrame:SetScript("OnEvent", OnEvent)

function LootAbfrage(tier,difficulty,instanceid,encounterid,class,spec,UpFunc)
	if currentQuery[1] then EJ:ClearQuery() end
	eventFrame.OnUpdate = UpFunc
	eventFrame:RegisterEvent("EJ_LOOT_DATA_RECIEVED")
	
	EJ_SelectTier(tier)
	EJ_SetDifficulty(difficulty)
	EJ_SelectInstance(instanceid)
	EJ_SelectEncounter(encounterid)
	EJ_SetLootFilter(class, spec)
	
	currentQuery[1] = instanceid
	currentQuery[2] = { encounterid, EJ_GetEncounterInfo(encounterid) }
	currentQuery[3] = difficulty
	currentQuery[4] = tier
	currentQuery[5] = class
	currentQuery[6] = spec
	
	local x, itemID, link
	for i = 1, EJ_GetNumLoot() do
		itemID, x, x, x , slot, armortype, link = EJ_GetLootInfoByIndex(i)
		itemList[i] = { itemID, link, slot, armortype }
		itemList[itemID] = i
	end
	
	UpFunc(itemList)
end

function EJ:ClearQuery()
	if not eventFrame.OnUpdate then return end
	eventFrame:UnregisterEvent("EJ_LOOT_DATA_RECIEVED")
	eventFrame.OnUpdate = nil
	table.wipe(itemList)
	table.wipe(currentQuery)
end