local Gnoll = _G.Gnoll
local GL = Gnoll.Locale
local GLW = Gnoll.WoWLocale
local GD = Gnoll.Data


local function OnEnterButton(self,link)
		GameTooltip:SetOwner(self, "ANCHOR_NONE")
		GameTooltip:SetPoint("BOTTOM", self, "LEFT", 0, 5)
		if link ~= nil then
			GameTooltip:SetHyperlink(link)
		end
end

local function OnLeaveButton(self)
	GameTooltip:Hide()
end

function CreateWishButtons(Frame)
	WishButtons = { { } }
	for i=1, 30 do
		if i <= 10 then
			abstand = i*40
			spalte = 55
		elseif i >= 11 and i <= 20 then 
			 abstand = (i-10) *40
			 spalte = 250+55
		elseif i >= 21 and i <= 30 then
			 abstand = (i-20) *40
			 spalte = 500+55
		end
			
		WishButtons[i] = CreateFrame("Button", nil, Frame)
		button = WishButtons[i]
		
		button:SetPoint("Topleft", Frame, 0+spalte-32, 0-abstand)
		button:SetWidth(232)
		button:SetHeight(32)
			
		local fo = button:CreateFontString()
			fo:SetFont("Fonts/FRIZQT__.TTF",11)
			fo:SetPoint("LEFT", button, "LEFT", 34,8)
			button:SetFontString(fo)
		
		local ntex = button:CreateTexture()
		ntex:SetTexture("Interface/FrameGeneral/UI-Background-Marble")
		ntex:SetAlpha(0.8) 
		ntex:SetAllPoints()
		button:SetNormalTexture(ntex)
		button:SetScript("OnLeave", OnLeaveButton)
		button:Hide()
		
		
		button.icon = CreateFrame("Button", nil, button)
		icon = button.icon
		
		icon:SetPoint("Left", button, 0, 0)
		icon:SetWidth(32)
		icon:SetHeight(32)
		
		local itex = icon:CreateTexture()
		itex:SetTexture("Interface\ICONS\Ability_Creature_Cursed_03")
		itex:SetAllPoints()
		icon:SetNormalTexture(itex)
		icon:Show()
		
		local fo = icon:CreateFontString()
		fo:SetFont("Fonts/FRIZQT__.TTF",9)
		fo:SetPoint("LEFT", button, "LEFT", 34,-10)
		icon:SetFontString(fo)
		
		
	end
end

function ClearWishButtons()
	for i=1,30 do
		WishButtons[i]:Hide()
	end
end

function ShowWishPage(self,button,arg2)
	local WishList = Gnoll.DB["wunschliste"]
	local itemTable = { }
	
	local count = 0
	for k,v in pairs(WishList) do  -- K = itemid V =  Table
		count = count + 1
		itemTable[count] = { }
		itemTable[count]["id"] = k
		itemTable[count]["table"] = v
	end
	local seite = -1
	local maxsites = math.ceil(#itemTable / 30)
	if arg2 == nil then 
		seite = 1 
	else 
		if arg2 > maxsites then
			seite = maxsites
		elseif arg2 < 1 then
			seite = 1
		else
			seite = arg2 
		end
	end 
	local start = 30 * seite -29
	local ende = 30 * seite
	
	WishPagetext:SetText(string.format("|cFFFFFFFF"..GL["Page %d of %d"], seite,maxsites))
	
	
	---Buttons mit Funktionen belegen
	WishSeiteLinks:SetScript("OnMouseDown", function(self, button,arg2)
		ShowWishPage(self,button, seite -1)
	end)
	WishSeiteRechts:SetScript("OnMouseDown", function(self, button,arg2)
		ShowWishPage(self, button, seite +1)
	end)
	WishFrame:SetScript("OnMouseWheel", function(self, delta)
		ShowWishPage(self, button, seite - delta)
	end)
	
	if ende >= count then -- more Items ?
		WishSeiteRechts:Hide()
	else
		WishSeiteRechts:Show()
	end
	
	if seite > 1 then 
		WishSeiteLinks:Show()
	else
		WishSeiteLinks:Hide()
	end
	
	if count < ende then -- not enough items :(
		ende = count
	end
	
	local buttonid = 1
	for i = start, ende do
		 local id = 0
		 local tmp = 0
		 
		 if i >= 31 then  --buttonid wird nicht übermittelt also ein kleiner workaround
			tmp = math.floor(i / 30)
			id = i - tmp*30
		 else
			id = i
		 end
	
	
		WishButtons[buttonid]:Show()
		WishButtons[buttonid]:SetAlpha(1) 
		--Inhalt
		local _, _, Farbe = string.find(itemTable[i]["table"][1],"|?c?f?f?(%x*)")
		local _, _, ItemName = string.find(itemTable[i]["table"][1],"|?h?%[?([^%[%]]*)%]")
		if strlen(ItemName) > 30 then ItemName = strsub(ItemName,0,30).."..." end 
		WishButtons[buttonid]:SetText("|cff"..Farbe..ItemName)
		--Tooltip
		WishButtons[buttonid]:SetScript("OnEnter", function(self,arg1)
			OnEnterButton(self,itemTable[i]["table"][1])
			end)
		--Icon
		texture = GetItemIcon(itemTable[i]["id"])
		local kontinent = tonumber(itemTable[i]["table"][2])
		local instanz  = tonumber(itemTable[i]["table"][3])
		local boss = tonumber(itemTable[i]["table"][4])
		local ausgabe = ""
		local modulini = 0
		local art = 0
		local addonkontinent = 0
	
		if (kontinent > #GD["Addons"]) then -- abfrage ob extra addon
			addonkontinent = kontinent - #GD["Addons"]
			art = 1
		else
			modulini = instanz - #GD["Instanzen"][kontinent]
		end
		
		WishButtons[buttonid].icon:SetNormalTexture(texture)
		WishButtons[buttonid]:SetScript("OnClick", function(self, button)
				 if button == "LeftButton" then 
					 if(IsShiftKeyDown()) then
						 local e = DEFAULT_CHAT_FRAME.editBox
						 local tmp = e:GetText()
						
						 ChatEdit_ActivateChat(e)
						 e:SetText(tmp .. itemTable[i]["table"][1])
					
					 elseif(IsControlKeyDown()) then
						DressUpItemLink(itemTable[i]["table"][1])
					
					elseif(IsAltKeyDown()) then
						 if type(WishList[itemTable[i]["id"]]) ~= "table" then
							 WishList[itemTable[i]["id"]] = { itemTable[i]["table"][1] ,kontinent,instanz,boss}
							 print(itemTable[i]["table"][1].." "..GL["ItemWishlistADD"])
							 WishButtons[id]:SetAlpha(1) 							 
						 else
							WishList[itemTable[i]["id"]] = nil
							print(itemTable[i]["table"][1].." "..GL["ItemWishlistDEL"])
							WishButtons[id]:SetAlpha(0.5) 
						 end
					 end
				 end
			 end)
			 
			WishButtons[buttonid].icon:SetScript("OnClick", function(self, delta)
				QuickSelect(kontinent,instanz,boss)
			end)
			 
		---Herkunft des Item
		if art == 0 then
			if instanz > #GD["Instanzen"][kontinent] then	-- Modulwishlist
				ini = GD["Addons"][kontinent]
				bossaus = GD["ModulData"][kontinent][modulini][boss]
				if string.find(bossaus,"f###") ~= nil then
					local _, start = string.find(bossaus,"f###")
					local id = string.sub(bossaus, start+1)
					bossaus = GetFactionInfoByID(id)
				elseif string.find(bossaus,"e###") ~= nil then
					local _, start = string.find(bossaus,"e###")
					local id = string.sub(bossaus, start+1)
					bossaus = EJ_GetEncounterInfo(id)
				end
				ausgabe = bossaus.." - "..ini
				if strlen(ausgabe) > 30 then ausgabe = strsub(ausgabe,0,30).."..." end
				WishButtons[buttonid].icon:SetText(ausgabe)
				
			else 	-- "normale Wishlist"
				if GD["MapIDS"][kontinent][instanz] == GL["World Bosses"] then
					ini = GD["MapIDS"][kontinent][instanz]
				else
					ini = GetMapNameByID(GD["MapIDS"][kontinent][instanz])
				end
				bossaus = EJ_GetEncounterInfo(GD["Bosse"][kontinent][instanz][boss])
				ausgabe = bossaus.." - "..ini
				if strlen(ausgabe) > 30 then ausgabe = strsub(ausgabe,0,30).."..." end
				WishButtons[buttonid].icon:SetText(ausgabe)
			end
		else
			ini = GD["AddonModulData"][addonkontinent][instanz]
			WishButtons[buttonid].icon:SetText(ini)
		end		
		
		buttonid = buttonid +1
	end
	
	if buttonid < 30 then -- not enough items :(
		for i = buttonid, 30 do
			WishButtons[buttonid]:Hide()
			buttonid = buttonid +1
		end
	end
end