local _G = _G
_G.Gnoll =  {}

local MainMT = {
	__tostring = function(self)
		return AddonNameVersion
	end,
}
setmetatable(_G.Gnoll, MainMT)

function newtable(dim)
    local MT = {};
    for i=1, dim do
        MT[i] = {__index = function(t, k)
            if i < dim then
                t[k] = setmetatable({}, MT[i+1])
                return t[k];
            end
        end}
    end
    return setmetatable({}, MT[1]);
end

_G.Gnoll.Locale = {}
_G.Gnoll.WoWLocale = {}
_G.Gnoll.Data = {} 
_G.Gnoll.DB = {} 


local frame = CreateFrame("FRAME")
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_LOGOUT")

function frame:OnEvent(event, arg1)
	if event == "ADDON_LOADED" and arg1 == "Gnoll" then

		if type(GnollDatabase) ~= "table" then -- neue DB anlegen
			print("[Gnoll] Default Database loaded.")
			GnollDatabase = { "wunschliste","favoriten" }
			GnollDatabase["wunschliste"] = {}
			GnollDatabase["favoriten"] = {}
		 
		else --- Features einzeln adden
			if type(GnollDatabase["wunschliste"]) ~= "table" then
				GnollDatabase["wunschliste"] = {}
				print("[Gnoll] New Feature: Wishlist ")
			end
			
			if type(GnollDatabase["favoriten"]) ~= "table" then
				GnollDatabase["favoriten"] = {}
				print("[Gnoll] New Feature: Favourites ")
			end
		end
	
	
	_G.Gnoll.DB = GnollDatabase
	end
end
frame:SetScript("OnEvent", frame.OnEvent);

 



